function [wavex,period,scale,coi] = WaveletPSD(X,dt,pad,minFreq,N,maxFreq,mother,param);

if (nargin < 8);param=-1;end;
if (nargin < 7);mother=-1;end;
if (nargin < 6);maxFreq=-1;end;
if (nargin < 5);N=50;end;
if (nargin < 4);minFreq=-1;end;
if (nargin < 3);pad=0;end;
if (nargin < 2)
	error('Must input a vector Y and sampling time DT')
end

% make sure that you have a mother/param !
if (mother == -1);mother='MORLET';end;
if (param == -1)
    switch mother
        case {'MORLET','morlet','Morlet'}
            param=6;
        case {'PAUL','paul','Paul'}
            param=4;
        case {'DOG','dog','D.O.G.','d.o.g.','Dog'}
            param=2;
    end
end
% MaxFreq = MinWavelength = 2*dt (Nyquist)
if (maxFreq == -1);maxFreq=1/(2*dt);end;
% MinFreq = MaxWavelength = length/2
if (minFreq == -1);minFreq=1/(length(X)/2);end;

%---------------------ALL PARAMETERS HAVE VALUES---------------------------

% calculate FourierFactor
fourierFactor=0;
switch mother
        case {'MORLET','morlet','Morlet'}
            fourierFactor=4*pi/(param+sqrt(2+param^2));
        case {'PAUL','paul','Paul'}
            fourierFactor=4*pi/(2*param+1);
        case {'DOG','dog','D.O.G.','d.o.g.','Dog'}
             fourierFactor=2*pi/sqrt(param+1/2);
end
if(fourierFactor==0);error('Unknown or badly typed mother function!');end;

dj = .25;
s0 = 2*dt;
sMAX = 3600; % maximum scale in seconds
j1 = round(log2(sMAX/s0))/dj;

[wavex,period,scale,coi]=wavelet(X,dt,pad,dj,s0,j1,mother,param);
end